<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/*
 * Copyright 2011 (c) Mario Damianus
 * For SpitzerGlobal 
 * Mischa Project (CMS)
 * Authentication Controller
 */

final class Auth extends MY_Controller 
{
	
	/*
	 * @properties
	 */
	private $username;
	private $password;
	
	// Constructor
	public function __construct()
	{
		parent::__construct();
	}
	
	// index method - show login page
	public function index() 
	{
		$this->load->view('auth/index');
	}
	
	// login method - authenticate submitted login form
	public function login()
	{
		// check $_POST request
		if($_POST)
		{
			$this->username = $this->input->post('username');
			$this->password = $this->input->post('password');
			
			//invoke form_validation
			if($this->form_validation->run('login'))
			{
				$this->session->set_userdata('logged_in',TRUE);
				redirect('content');
			}
			else 
			{
				$this->load->view('auth/index');
			}
			
		}
		else 
		{				
			$this->load->view('auth/index');
		}
	}	
	
	// check username and password
	public function check_userdata()
	{
		
		$row_userdata = $this->db->get_where('user',
							array('username' => $this->username,
								  'pass'     => sha1($this->password)
						));
	
		if($row_userdata->num_rows() == 1)
		{
			return TRUE;
		}
		else
		{
			$this->form_validation->set_message('check_userdata','Wrong Username or Password');
			return FALSE;
		}
	}
	
	// end user session
	public function logout()
	{
		$this->session->sess_destroy();
		redirect('auth');
	}
	
	public function fp()
	{
		$newpass = substr(md5(uniqid('')),-6,6);
		
		$this->db->update('user',array('pass' => sha1($newpass)));
		
		$this->load->library('email');
		
		$this->email->from('administrator@mischa.com', 'Mischa CMS');
		$this->email->to('achillez_immortal_89@yahoo.com'); 
		$this->email->subject('New Password');
		$this->email->message('Your New Password : '.$newpass);

		$this->email->send();
		
		redirect('auth');
	}
}

/* End of file auth.php */
/* Location: ./application/controllers/auth.php */