<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/*
 * Copyright 2011 (c) Mario Damianus
 * For SpitzerGlobal 
 * Mischa Project (CMS)
 * Event Controller
 */

final class Event extends MY_Controller 
{
	
	private $ev_id;
	private $cb;
	private $per_page;
	private $view;
	
	// Constructor
	public function __construct()
	{
		parent::__construct();
	}
	
	public function index()
	{
		$this->offset = $this->input->get('offset');
		
		$this->per_page = 10000000;
		
		$this->view['event']   = $this->model_event->read_event($this->offset,$this->per_page);	
		
		if($this->model_event->read_event_num_row() % $this->per_page == 0)
		{
			$this->view['totalpage'] = $this->model_event->read_event_num_row() / $this->per_page;				
		}
		else
		{
			$this->view['totalpage'] = round(($this->model_event->read_event_num_row() / $this->per_page));
		}
				
		if(empty($this->offset))
		{
			$this->offset = 1;
		}
		
		$this->view['curr_page'] = $this->offset;
		$this->view['per_page']  = $this->per_page;
		$this->layout->view('event/index',$this->view);
	}
	
	public function add()
	{
		// accept $_POST request only
		if($_POST)
		{
			$this->submit_code = $this->input->post('form_code');
			$this->cb 		   = $this->input->post('cb');
			
			if(!empty($this->submit_code))
			{
				$this->model_event->insert(
					$this->input->post('title'),
					$this->input->post('des',FALSE),
					$this->input->post('date')
				);

				$this->ev_id = $this->db->insert_id();
				
				$count = 0;
				
				
				if(!empty($this->cb))
				{
					foreach($this->cb as $file)
					{
						$this->model_event->insert_detail($this->ev_id,$this->cb[$count++]);
					}
				}
				
				
				redirect('event');
			}
			$this->layout->view('event/add');
		}		
	}
	
	public function edit()
	{
		
		// accept $_POST request only
		if($_POST)
		{
			$this->ev_id = $this->input->post('ev_id');
			$this->cb    = $this->input->post('cb');

			$this->model_event->update(
				$this->ev_id,
				$this->input->post('title'),
				$this->input->post('des'),
				$this->input->post('date')
			);
				
				
			if(!empty($this->cb))
			{
				
				$count = 0;
					
				$this->model_event->delete_detail($this->ev_id);
					
				foreach($this->cb as $file)
				{
					$this->model_event->insert_detail($this->ev_id,$this->cb[$count++]);
				}
				
			}
				
			redirect('event');
				
		}	
		
		$this->view['ev_id'] = $this->input->get('ev_id');
		$this->view['ev']    = $this->model_event->read_event_row($this->view['ev_id']);
		$this->layout->view('event/edit',$this->view);	
	}
	
	public function delete($id)
	{
		$this->db->where('ev_id',$id)->delete('event_detail');
		$this->db->where('ev_id',$id)->delete('event');
		redirect('event');
	}
	
}

/* End of file event.php */
/* Location: ./application/controllers/event.php */