<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/*
 * Copyright 2011 (c) Mario Damianus
 * For SpitzerGlobal 
 * Mischa Project (CMS)
 * Authentication Controller
 */

final class File extends MY_Controller 
{
	
	private $cc_id;
	private $upload_path;
	private $view 		 = array();
	private $file 		 = array();
	private $upload_data = array();
	
	// Constructor
	public function __construct()
	{
		parent::__construct();
	}
	
	private function get_dir_path()
	{ 		
		switch ($this->cc_id) 
		{
			case 1:$this->upload_path = './../images/slide/';
				   break;
			case 2:$this->upload_path = './../images/gallery/full/';
				   break;
			case 3:$this->upload_path = './../images/about/';
				   break;
			case 4:$this->upload_path = './../images/event/photo/';
				   break;
		}
	}
	
	private function get_dir2_path()
	{ 		
		switch ($this->cc_id) 
		{
			case 1:$this->upload_path = './../images/slide/';
				   break;
			case 2:$this->upload_path = './../images/gallery/thumbnails/';
				   break;
			case 3:$this->upload_path = './../images/about/';
				   break;
			case 4:$this->upload_path = './../images/event/thumb/';
				   break;
		}
	}
	
	private function do_resize($file_name)
	{
		$config['image_library'] = 'gd2';
		$config['create_thumb'] = TRUE;
		$config['maintain_ratio'] = TRUE;
		
		switch ($this->cc_id) 
		{
			case 2:$config['source_image'] = './../images/gallery/full/'.$file_name;
				   $config['new_image']    = './../images/gallery/photos/'.$file_name;
				   $config['width']  = 800;
				   $config['height'] = 400;
				   $this->image_lib->initialize($config);		   
				   $this->image_lib->resize();
				   
				   $this->image_lib->clear();
				   
				   $config['source_image'] = './../images/gallery/full/'.$file_name;
				   $config['new_image']    = './../images/gallery/thumbnails/'.$file_name;
				   $config['width']  = 200;
				   $config['height'] = 75;
				   $this->image_lib->initialize($config);		   
				   $this->image_lib->resize();
				   
				   break;
				   
			case 4:$config['source_image'] = './../images/event/photo/'.$file_name;
				   $config['new_image']    = './../images/event/thumb/'.$file_name;
				   $config['width']  = 200;
				   $config['height'] = 150;
				   $this->image_lib->initialize($config);
				   $this->image_lib->resize();
				   
				   break;
		}
	}
	
	// method index
	public function index()
	{			
		// upload file
		if($_POST)
		{
			$this->cc_id = $this->input->post('cc_id');
			
			foreach($_FILES as $key => $value)
			{
				if(!empty($value['name']))
				{
					$this->get_dir_path();
					
					$config['upload_path']   = $this->upload_path;
					$config['allowed_types'] = '*';
					$config['max_size']	     = '2048';
					$this->upload->initialize($config);
					
					if(file_exists($this->upload_path.$value['name']))
					{
						$this->session->set_flashdata('upload_error',$value['name'].' already exists');
						redirect('file');
					}
					else if($this->upload->do_upload($key))
					{
						$this->do_resize($value['name']);
						
						$this->upload_data = $this->upload->data();
						
						$this->model_file->insert(
							$this->upload_data['file_name'],
							$this->cc_id
						);

					} else {
						$this->session->set_flashdata('upload_error',$this->upload->display_errors());
						redirect('file');
					}
				}
			}
			
			redirect('file');
			
		}
		else
		{
			$this->cc_id = $this->input->get('cc_id');
			
			if(!is_null($this->cc_id) AND !empty($this->cc_id))
			{
				$this->view['cc_id'] = $this->cc_id;
			}
			else 
			{
				$this->view['cc_id'] = 1;
			}
			
			$this->layout->view('file/index',$this->view);
		}
	}
	
	public function delete_file_from_folder($cc_id,$file_id)
	{
		
		$file = $this->model_file->read_file_by_file_id($file_id);
		
		switch($cc_id)
		{
			case 1:if(file_exists('./../images/slide/'.$file->file_path))
						unlink('./../images/slide/'.$file->file_path);
				   break;
			case 2:if(file_exists('./../images/gallery/full/'.$file->file_path) AND file_exists('./../images/gallery/photos/'.$file->file_path) AND file_exists('./../images/gallery/thumbnails/'.$file->file_path))
				   {
						unlink('./../images/gallery/full/'.$file->file_path);
						unlink('./../images/gallery/photos/'.$file->file_path);
						unlink('./../images/gallery/thumbnails/'.$file->file_path);
				   }
				   break;
			case 3:if(file_exists('./../images/about/'.$file->file_path))
						unlink('./../images/about/'.$file->file_path);
				   break;
			case 4:if(file_exists('./../images/event/photo/'.$file->file_path) AND file_exists('./../images/event/thumb/'.$file->file_path))
				   {
						unlink('./../images/event/photo/'.$file->file_path);
						unlink('./../images/event/thumb/'.$file->file_path);
				   }	
				   break;
		}
	}
	
	public function partial($action = null, $cc_id = null, $file_id = null, $page = null)
	{
		if($this->input->is_ajax_request())
		{
			if(md5('all') == $action)
			{
				$this->show_all($cc_id,$page);
			}
			else if(md5('delete') == $action)
			{
				if($this->model_file->check_file($cc_id,$file_id))
				{
					$this->delete_file_from_folder($cc_id,$file_id);
					$this->model_file->delete($file_id);
					$this->show_all($cc_id,$page);
				}
				else 
				{
					echo '<p>File is currently in use</p>';
				}
				
			}
			else if(md5('multiple') == $action)
			{
				$this->show_multiple($cc_id,$page);
			}
			else if(md5('multipleevent') == $action)
			{
				$this->show_multiple_by_event($cc_id,$file_id);
			}
			else 
			{
				exit('No direct access allowed');
			}
		} 
		else 
		{
			exit('No direct access allowed');
		}
	}
	
	private function show_all($cc_id,$page)
	{
		$this->cc_id = $cc_id;
		$this->get_dir2_path();
				
		$this->view['file_path'] = str_replace('./../', '/', $this->upload_path); 		
		$this->view['row']       = $this->model_file->read_file_list_by_ccid_num_row($this->cc_id);
		$this->view['list_file'] = $this->model_file->read_file_list_by_ccid($this->cc_id,$page);
		$this->load->view('file/list',$this->view);
	}
	
	private function show_multiple($cc_id,$page)
	{
		$this->cc_id = $cc_id;
		$this->get_dir2_path();
				
		$this->view['file_path'] = str_replace('./../', '/', $this->upload_path); 		
		$this->view['row']       = $this->model_file->read_file_list_by_ccid_num_row($this->cc_id);
		$this->view['list_file'] = $this->model_file->read_file_list_by_ccid($this->cc_id,$page);
		$this->load->view('file/multiple',$this->view);
	}
	
	private function show_multiple_by_event($cc_id,$ev_id)
	{
		$page = null;
		
		$this->cc_id = $cc_id;
		$this->get_dir2_path();
				
		$this->view['file_path'] = str_replace('./../', '/', $this->upload_path); 		
		$this->view['current']   = $this->model_file->read_current_event_file($ev_id);
		$this->view['row']       = $this->model_file->read_file_list_by_ccid_num_row($this->cc_id);
		$this->view['list_file'] = $this->model_file->read_file_list_by_ccid($this->cc_id,$page);
		$this->load->view('file/multiple2',$this->view);
	}
	
}

/* End of file file */
/* Location: ./application/controllers/file.php */